
$(document).ready(function(){
    //loading
    $('#loadingContainer').ajaxStart(function(){
	    $(this).show();
	    $('#loadingbackground').show().css({"opacity": "0.5"});
	}).ajaxStop(function(){
	    $(this).hide();
	});
	
	setInterval(function(){
        if(getQueryStringRegExp('from') != 'list'){
            $('div.save').css('top',$(window.parent.frames.right).height()-$('div.save').height()); //设置底部分页区域的位置
            $('div.sub_container_content').css('height',$(window.parent.frames.right).height()-$('div.save').height()-$(".sub_container_title").height()-$(".tabmenu").height()-20); //设置内容区域的高度
        }else{//从列表页面链接过来修改
            var windowHeight = $('#frmHeight',window.parent.document).val();
            $('div.save').css('top',windowHeight-$('div.save').height()); //设置底部分页区域的位置
            $('div.sub_container_content').css('height',windowHeight-$('div.save').height()-$(".sub_container_title").height()-$(".tabmenu").height()-20); //设置内容区域的高度
        }
    },100);
    
    $('#btnCancel').click(function(){
        if(getQueryStringRegExp('from') == 'list'){
            $('#frmModify',window.parent.document).hide().siblings(':not("#loadingContainer")').show();
            return false;
        }
    });
	
    settab();//顶部tab
    CheckAlert();
    SetThumbnail();
    $('#cbxNeedAlert').click(function(){CheckAlert()});
    $('#cbxFromBigPic').click(function(){SetThumbnail();});
    $('#customchoiceCount').val($('input[@type=checkbox][@name^=checkbox_]').length);//扩展属性CheckBox的个数
    $('#customselectCount').val($('select[@name^=ddlFildValues_]').length);//扩展属性Select的个数
    
    if(getQueryStringRegExp('ProductID') == ''){$('#cbxAutoCreate').attr('checked','checked')};//添加商品默认将checkbox选中
    $('#cbxAutoCreate').attr('checked') ? $('#txtProductNo').hide() : $('#txtProductNo').show();
    $('#cbxAutoCreate').click(function(){
        if($(this).attr('checked')){
            $('#txtProductNo').hide();
        }else{
            $('#txtProductNo').show();
        }
    });
    
    //当扩展属性为select控件时,若选择的Value为0,就将文本框显示出来
    $('select[@name^=ddlFildValues_]').each(function(){
        SelectFieldValue($(this));
        $(this).change(function(){
            SelectFieldValue($(this));
        });
    });
    $('input[@id^=txtFieldValue_]').keyup(function(){$(this).val($(this).val().replace(/\|/g,''))});
    
    //选择类别显示扩展属性
    $('#lbxCategories').change(function(){
        var categoryIDs = $(this).val();
        //获取扩展属性
        var urlProductID = getQueryStringRegExp("ProductID") == "" ? "" : "ProductID="+parseInt(getQueryStringRegExp("ProductID"));
        $.ajax({
            url:'ProductAdd.aspx?type=ajax&Action=GetFieldValues&product_category_id='+categoryIDs + '&' + urlProductID + '&NoCopyRight=1',
            cache:false,
            success:function(data){
                if(!checkLoginStatus(data)){return false;}//是否要重新登陆
                if(data != ''){
                    $('#tb_productfield').html(data);
                    $('select[@name^=ddlFildValues_]').each(function(){
                        SelectFieldValue($(this));
                        $(this).change(function(){
                            SelectFieldValue($(this));
                        });
                        $('input[@id^=txtFieldValue_]').keyup(function(){$(this).val($(this).val().replace(/\|/g,''))});
                    });
                    $('#customchoiceCount').val($('input[@type=checkbox][@name^=checkbox_]').length);//扩展属性CheckBox的个数
                    $('#customselectCount').val($('select[@name^=ddlFildValues_]').length);//扩展属性Select的个数
                }else{
                    $('#tb_productfield tr').remove();//如果为空,将表内的内容清除
                }
            },//end seccess
            error:function(){alert('error');}
        });//end ajax
        
        //获取品牌
        $.ajax({
            url:'ProductAdd.aspx?type=ajax&Action=GetBrandByCatID&product_category_id='+categoryIDs + '&NoCopyRight=1',
            cache:false,
            success:function(data){
                $('#ddlBrand').html(data);
            },
            error:function(){alert('error');}
        });
        return false;
    });
    
    $('#btnAddFile').click(function(){
        var str = '<br><INPUT type="file" NAME="File">';
        $('#FileCollection').append(str);
    });
    //删除相关图片
    $('a:contains("删除")','#dgRelatedImgs').each(function(index){
        $(this).click(function(){
            var productID = getQueryStringRegExp('ProductID');
            var img = $('a:contains("relatedImgs_")','#dgRelatedImgs').eq(index).html();//要删除的图片名
            $.ajax({
                url:'ProductAdd.aspx?type=ajax&Action=DeleteRelatedImgByAjax&ProductID='+productID + '&ItemIndex=' + index + '&img=' + img + '&NoCopyRight=1',
                cache:false,
                success:function(data){
                    if(!checkLoginStatus(data)){return false;}//是否要重新登陆
                    if(data == 1){$('tr:contains("relatedImgs_")','#dgRelatedImgs').eq(index).remove();}    //如果返回值为1,就将行删除
                },
                error:function(){alert('error');}
            });
            return false;
        });
    });
    
    //搜索相关商品
    $('#btnAbout').click(function(){
        $.ajax({
            url:'ProductAdd.aspx?type=ajax&Action=SearchProductAjax&keyword=' + escape($('#txtAboutKey').val()) + '&NoCopyRight=1',
            cache:false,
            success:function(data){
                if(!checkLoginStatus(data)){return false;}//是否要重新登陆
                if(data != ''){
                    $('#search_result_head').siblings().remove();
                    $('#search_result_head').after(data).show();
                }else{
                    $('#search_result_head').siblings().remove();
                }
            },//end success
            error:function(){alert('error');}
        });//end ajax
        
        return false;
    });
    //相关商品 全选/取消
    $('#chkAll_list').click(function(){$('input[@name=chkItem_list]').attr('checked',$(this).attr('checked'))});
    $('#chkAll_search').click(function(){$('input[@name=chkItem_search]').attr('checked',$(this).attr('checked'))});
    //保存前先检测填写是否正确
    $('#btnSave').click(function(){if(!check()){return false}});
    
});

function SelectFieldValue(obj){
    var index = obj.attr('name').split('_')[1];
    if(obj.val() == '0'){$('#span_fieldvalue_'+index).show();}else{$('#span_fieldvalue_'+index).hide();}
}	

//是否显示库存警告数量
function CheckAlert(){if($('#cbxNeedAlert').attr('checked')){$("#mininum").show();}else{$("#mininum").hide();}}
//是否显示缩图宽度
function SetThumbnail(){if($('#cbxFromBigPic').attr('checked')){$("#ThumbnailPic").hide();}else{$("#ThumbnailPic").show();}}

//tab
function settab(){
    var items = $('li.menuitem').length;
    $('li.menuitem').each(function(index){
        $(this).click(function(){
            $(this).addClass('tabon').removeClass('tabout').siblings('.menuitem').removeClass('tabon').addClass('tabout');
            if(index != 0){
                $('div.tab').hide();
                $('div.tab').eq(index - 1).show();
            }else{
                $('div.tab').show();
            }
        });
    });
}

function check(){
    var floatReg = new RegExp(/[^\d\.]/g);
    var intReg = new RegExp(/[^\d]/g);//整数
    var posIntReg = new RegExp(/^[1-9]*[1-9][0-9]*$/g);//正整数
    if($('#txtName').val().Trim() == ''){alert('商品名称必须填写');return false;}
    if(!$('#cbxAutoCreate').attr('checked')){if($('#txtProductNo').val().Trim() == ''){alert('商品编号必须填写');return false;}}
    if($('#txtUnit').val().Trim() == ''){alert('商品单位必须填写');return false;}
    if($('#txtWeight').val().Trim() == ''){alert('单位重量必须填写');return false;}else if(floatReg.test($('#txtWeight').val().Trim())){alert('单位重量填写不正确');return false;}
    if($('#txtScore').val().Trim() == ''){alert('积分必须填写');return false;}else if(intReg.test($('#txtScore').val().Trim())){alert('积分填写不正确');return false;}
    if($('#txtMarketPrice').val().Trim() == ''){alert('市场价格必须填写');return false;}else if(floatReg.test($('#txtMarketPrice').val().Trim())){alert('市场价格填写不正确');return false;}
    if($('#txtMemberPrice').val().Trim() == ''){alert('会员价格必须填写');return false;}else if(floatReg.test($('#txtMemberPrice').val().Trim())){alert('会员价格填写不正确');return false;}
    if($('#txtMin').val().Trim() == ''){alert('最低购买量必须填写');return false;}else if(intReg.test($('#txtMin').val().Trim())){alert('最低购买量填写不正确');return false;}
    if($('#lbxCategories').val() == null){alert('请至少选择一个分类');return false;}
    
    //图片格式
    var imgpass = true;
    $('input[@type=file]').each(function(){
        if($(this).val().Trim() != ''){
            var extendName = $(this).val().substring($(this).val().lastIndexOf('.'));
            if(extendName.toLowerCase() != '.gif' && extendName.toLowerCase() != '.jpg')
            {
                imgpass = false;
            }
        }
    });
    if(!imgpass){alert('产品图片只支持.gif或者.jpg格式');return false;}
    
    if($('#cbxFromBigPic').attr('checked')){if(! posIntReg.test($('#txtPicWidth').val())){alert('缩略图宽度不正确');return false;}}
    if($('#txtStorage').val().Trim() == ''){alert('最新入库数量填写不正确');return false;}else if(intReg.test($('#txtStorage').val().Trim())){alert('最新入库数量填写不正确');return false;}
    if($('#txtMininum').val().Trim() == ''){alert('库存警告数量填写不正确');return false;}else if(intReg.test($('#txtMininum').val().Trim())){alert('库存警告数量填写不正确');return false;}
    
    var isNoExists = false;//判断商品编号是否存在
    if(getQueryStringRegExp("ProductID") == ""){//添加商品
        $.ajax({
            url:'ProductAdd.aspx?type=ajax&Action=IsExistProductNo&ProductNo='+escape($('#txtProductNo').val()) + '&NoCopyRight=1',
            async:false,
            cache:false,
            success:function(data){
                if(!checkLoginStatus(data)){return false;}//是否要重新登陆
                if(data==0){isNoExists = false;}else{isNoExists = true;}
            },
            error:function(){alert('error')}
        });
    }else{//修改商品
        $.ajax({
            url:'ProductAdd.aspx?type=ajax&Action=IsExistProductNo&ProductNo='+escape($('#txtProductNo').val())+'&ProductID='+getQueryStringRegExp("ProductID") + '&NoCopyRight=1',
            async:false,
            cache:false,
            success:function(data){
                if(!checkLoginStatus(data)){return false;}//是否要重新登陆
                if(data==0){isNoExists = false;}else{isNoExists = true;}
            },
            error:function(){alert('error')}
        });
    }
    if(isNoExists){alert('此商品编号已存在！');return false;}
    
    return true;
}

//获取URL中参数
function getQueryStringRegExp(name){    
	var reg = new RegExp("(^|\\?|&)"+ name +"=([^&]*)(\\s|&|$)", "i");
	if (reg.test(location.href))
		return unescape(RegExp.$2.replace(/\+/g, " "));
		return "";
}
//去掉字符串前后空格
String.prototype.Trim = function() 
{ 
    return this.replace(/(^\s*)|(\s*$)/g, ""); 
} 

function checkLoginStatus(data){
    var result = true;
    if(data.indexOf('<!DOCTYPE') != -1){
        result = false;
        alert('身份已过期,请重新登陆!');
    }
    return result;
}

function ManageCustomFields(pid)
{
    temp=window.open('ProductCustomField.aspx?productid='+pid,'customfield','width=680,height=600,scrollbars=yes,top=0,left=0');
    temp.focus();
}